## vcmi 0.97+dfsg

=== CMakeLists.txt ===
project(vcmi)
cmake_minimum_required(VERSION 2.8.12)
# TODO:
# 1) Detection of Qt5 and compilation of launcher, unless explicitly disabled

# where to look for cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake_modules)

# enable Release mode but only if it was not set
if (NOT CMAKE_BUILD_TYPE)
		set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# VCMI version
set(VCMI_VERSION_MAJOR 0)
set(VCMI_VERSION_MINOR 96)
set(VCMI_VERSION_PATCH 0)

option(ENABLE_ERM "Enable compilation of ERM scripting module" OFF)
option(ENABLE_EDITOR "Enable compilation of map editor" OFF)
option(ENABLE_LAUNCHER "Enable compilation of launcher" ON)
option(ENABLE_TEST "Enable compilation of unit tests" OFF)
option(ENABLE_PCH "Enable compilation using precompiled headers" ON)
option(ENABLE_SDL2 "Use SDL2 for compilation instead of SDL 1.2" ON)

############################################
#        Building section                  #
############################################

if (APPLE)
	# Default location for thirdparty libs
	set(CMAKE_INCLUDE_PATH "../include" "${CMAKE_OSX_SYSROOT}/usr/include")
	set(CMAKE_LIBRARY_PATH "../lib")
	set(CMAKE_FRAMEWORK_PATH "../Frameworks")
	set(BOOST_ROOT "../")

	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_HOME_DIRECTORY}/bin")
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_HOME_DIRECTORY}/bin")
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_HOME_DIRECTORY}/bin")

	set(CMAKE_XCODE_ATTRIBUTE_CONFIGURATION_BUILD_DIR "${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)")
	set(CMAKE_XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks @executable_path/")

	# Build with clang ang libc++
	set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")
	set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")

	# On OS X we use Sparkle framework for updates
	find_path(SPARKLE_INCLUDE_DIR Sparkle.h)
	find_library(SPARKLE_FRAMEWORK NAMES Sparkle)

	# Xcode 5.0 fix
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth=256")

	# Link with iconv
	set(SYSTEM_LIBS ${SYSTEM_LIBS} libiconv.dylib)
endif()

if (WIN32)
	add_definitions(-DBOOST_THREAD_USE_LIB)
	add_definitions(-D_WIN32_WINNT=0x0501)
	set(SYSTEM_LIBS ${SYSTEM_LIBS} ole32 oleaut32 ws2_32 mswsock)

	#delete lib prefix for dlls (libvcmi -> vcmi)
	set(CMAKE_SHARED_LIBRARY_PREFIX "") 

	if(MINGW)
		#MinGW: check for iconv (may be needed for boost.locale)
		include(CheckLibraryExists)
		check_library_exists(iconv libiconv_open "" ICONV_FOUND)
		if(ICONV_FOUND)
			set(SYSTEM_LIBS ${SYSTEM_LIBS} iconv)
		endif()

		#MinGW: copy runtime to VCMI location
		get_filename_component(MINGW_BIN_PATH ${CMAKE_CXX_COMPILER} PATH )
		set(dep_files ${dep_files} "${MINGW_BIN_PATH}/libwinpthread-*.dll") 
		set(dep_files ${dep_files} "${MINGW_BIN_PATH}/libgcc_s_*.dll") 
		set(dep_files ${dep_files} "${MINGW_BIN_PATH}/libstdc++-*.dll")

		#MinGW: use O1 to prevent compiler crash in some cases
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
	endif()

	if(MSVC)
		#MSVC: Fix problems with linking
		add_definitions(-DBOOST_ALL_NO_LIB)
		set(Boost_USE_STATIC_LIBS ON)

		#MSVC: Don't link with SDLMain
		set(SDL2_BUILDING_LIBRARY ON)

		#MSVC: Suppress warnings
		add_definitions(-D_CRT_SECURE_NO_WARNINGS)
		add_definitions(-D_SCL_SECURE_NO_WARNINGS)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /wd4251")
	endif()
endif()

if(NOT WIN32)
	INCLUDE(CheckLibraryExists)

	#check if some platform-specific libraries are needed for linking
	CHECK_LIBRARY_EXISTS(rt shm_open "" HAVE_RT_LIB)
	if(HAVE_RT_LIB)
		set(SYSTEM_LIBS ${SYSTEM_LIBS} rt)
	endif()

	CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_DL_LIB)
	if(HAVE_DL_LIB)
		set(SYSTEM_LIBS ${SYSTEM_LIBS} dl)
	endif()
endif()

set(FFmpeg_FIND_COMPONENTS AVFORMAT SWSCALE)
find_package(Boost 1.48.0 COMPONENTS filesystem locale program_options system thread REQUIRED)
find_package(ZLIB REQUIRED)
find_package(FFmpeg REQUIRED)
find_package(Minizip)
if (MINIZIP_FOUND)
    add_definitions(-DUSE_SYSTEM_MINIZIP)
endif()

if (ENABLE_SDL2)
	find_package(SDL2 REQUIRED)
	find_package(SDL2_image REQUIRED)
	find_package(SDL2_mixer REQUIRED)
	find_package(SDL2_ttf REQUIRED)

	set(SDL_INCLUDE_DIR "${SDL2_INCLUDE_DIR}")
	set(SDLTTF_INCLUDE_DIR "${SDL2_TTF_INCLUDE_DIR}")
	set(SDLIMAGE_INCLUDE_DIR "${SDL2_IMAGE_INCLUDE_DIR}")
	set(SDLMIXER_INCLUDE_DIR "${SDL2_MIXER_INCLUDE_DIR}")
	set(SDL_LIBRARY "${SDL2_LIBRARY}")
	set(SDLTTF_LIBRARY "${SDL2_TTF_LIBRARY}")
	set(SDLIMAGE_LIBRARY "${SDL2_IMAGE_LIBRARY}")
	set(SDLMIXER_LIBRARY "${SDL2_MIXER_LIBRARY}")
else()
	find_package(SDL REQUIRED)
	find_package(SDL_image REQUIRED)
	find_package(SDL_mixer REQUIRED)
	find_package(SDL_ttf REQUIRED)
endif()
include(cotire)

if (ENABLE_EDITOR OR ENABLE_LAUNCHER)
	# Widgets finds its own dependencies (QtGui and QtCore).
	find_package(Qt5Widgets REQUIRED)
endif()

if (ENABLE_LAUNCHER)
	find_package(Qt5Network REQUIRED)
endif()

if(ENABLE_TEST)
	# find_package overwrites BOOST_* variables which are already set, so all components have to be included again
	find_package(Boost 1.48.0 COMPONENTS program_options filesystem system thread locale unit_test_framework REQUIRED)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR NOT WIN32) #so far all *nix compilers support such parameters
	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		set(CLANG_SPECIFIC_FLAGS "-Wno-mismatched-tags -Wno-unknown-warning-option")
	endif()

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall -Wextra -Wpointer-arith -Wno-strict-aliasing -Wno-switch -Wno-sign-compare -Wno-unused-local-typedefs  -Wno-unused-parameter -Wuninitialized -Wno-overloaded-virtual -Wno-type-limits ${CLANG_SPECIFIC_FLAGS}")

	if(UNIX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
	endif()

endif()

if(WIN32) # on Win everything goes into H3 root directory
	set(BIN_DIR "." CACHE STRING "Where to install binaries")
	set(LIB_DIR "." CACHE STRING "Where to install main library")
	set(DATA_DIR "." CACHE STRING "Where to install data files")
elseif(APPLE)
	# includes lib path which determines where to install shared libraries (either /lib or /lib64)
	include(GNUInstallDirs)

	set(BIN_DIR "." CACHE STRING "Where to install binaries")
	set(LIB_DIR "." CACHE STRING "Where to install main library")
	set(DATA_DIR "../h3" CACHE STRING "Where to install data files")
else()
	# includes lib path which determines where to install shared libraries (either /lib or /lib64)
	include(GNUInstallDirs)

	if (NOT BIN_DIR)
		set(BIN_DIR "bin" CACHE STRING "Where to install binaries")
	endif()
	if (NOT LIB_DIR)
		set(LIB_DIR "${CMAKE_INSTALL_LIBDIR}/vcmi" CACHE STRING "Where to install main library")
	endif()
	if (NOT DATA_DIR)
		set(DATA_DIR "share/vcmi" CACHE STRING "Where to install data files")
	endif()
endif()

set (AI_LIB_DIR "${LIB_DIR}/AI")
set (SCRIPTING_LIB_DIR "${LIB_DIR}/scripting")

#define required constants
add_definitions(-DM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/${DATA_DIR}")
add_definitions(-DM_BIN_DIR="${CMAKE_INSTALL_PREFIX}/${BIN_DIR}")
add_definitions(-DM_LIB_DIR="${CMAKE_INSTALL_PREFIX}/${LIB_DIR}")

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/vcmi")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# precompiled header configuration
SET(PCH_PROPERTIES
	COTIRE_ENABLE_PRECOMPILED_HEADER ${ENABLE_PCH}
	COTIRE_ADD_UNITY_BUILD FALSE 
	COTIRE_CXX_PREFIX_HEADER_INIT "StdInc.h"
)

if (ENABLE_ERM)
		add_subdirectory(scripting/erm)
endif()
if (NOT MINIZIP_FOUND)
	add_subdirectory(lib/minizip)
	set(MINIZIP_LIBRARIES minizip)
endif()
add_subdirectory(lib)
add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(AI)
if (ENABLE_EDITOR)
	add_subdirectory(editor)
endif()
if (ENABLE_LAUNCHER)
	add_subdirectory(launcher)
endif()
if(ENABLE_TEST)
	add_subdirectory(test)
endif()

#######################################
#    Installation section             #
#######################################

# For apple this files will be already inside vcmiclient bundle
if (NOT APPLE)
	# copy whole directory but .svn control files
	install(DIRECTORY config DESTINATION ${DATA_DIR} PATTERN ".svn" EXCLUDE)
	# copy vcmi mod along with all its content
	install(DIRECTORY Mods/vcmi DESTINATION ${DATA_DIR}/Mods PATTERN ".svn" EXCLUDE)

	install(FILES vcmibuilder DESTINATION ${BIN_DIR} PERMISSIONS
		OWNER_WRITE OWNER_READ OWNER_EXECUTE
		            GROUP_READ GROUP_EXECUTE
		            WORLD_READ WORLD_EXECUTE)
endif()

if(WIN32)
	file(GLOB dep_files 
		${dep_files} 
		"${CMAKE_FIND_ROOT_PATH}/bin/*.dll")

	#Copy debug versions of libraries if build type is debug. Doesn't work in MSVC!
	if(CMAKE_BUILD_TYPE MATCHES DEBUG)
		set(debug_postfix d)
	endif(CMAKE_BUILD_TYPE MATCHES DEBUG)
	
	if (ENABLE_EDITOR OR ENABLE_LAUNCHER)
		get_target_property(QtCore_location Qt5::Core LOCATION)
		get_filename_component(Qtbin_folder ${QtCore_location} PATH)
		file(GLOB dep_files 
			${dep_files}
			${Qtbin_folder}/Qt5Core${debug_postfix}.dll
			${Qtbin_folder}/Qt5Gui${debug_postfix}.dll
			${Qtbin_folder}/Qt5Widgets${debug_postfix}.dll
			${Qtbin_folder}/icu*.dll)
		file(GLOB dep_qwindows
			${Qtbin_folder}/../plugins/platforms/qwindows${debug_postfix}.dll)
		if(MSVC)
			file(GLOB dep_files 
				${dep_files}
				${Qtbin_folder}/libEGL.dll
				${Qtbin_folder}/libGLESv2.dll)
		endif()
	endif()

	if (ENABLE_LAUNCHER)
		file(GLOB dep_files 
			${dep_files} 
			${Qtbin_folder}/Qt5Network${debug_postfix}.dll)
	endif()

	if(MSVC)
		#install MSVC runtime
		include(InstallRequiredSystemLibraries)
		install(FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} DESTINATION ${BIN_DIR})
	endif()
	install(FILES ${dep_files} DESTINATION ${BIN_DIR})
	install(FILES ${dep_qwindows} DESTINATION ${BIN_DIR}/platforms)
elseif(NOT APPLE)
	#install icons and desktop file on Linux
	#FIXME: move to client makefile?
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.64x64.png"   DESTINATION share/icons/hicolor/64x64/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.48x48.png"   DESTINATION share/icons/hicolor/48x48/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.32x32.png"   DESTINATION share/icons/hicolor/32x32/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.256x256.png" DESTINATION share/icons/hicolor/256x256/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.desktop"     DESTINATION share/applications)
	if (ENABLE_LAUNCHER) #FIXME: move to launcher makefile?
		install(FILES "${CMAKE_SOURCE_DIR}/launcher/vcmilauncher.desktop"     DESTINATION share/applications)
	endif()
endif()

#######################################
#       Packaging section             #
#######################################

set(CPACK_PACKAGE_VERSION_MAJOR ${VCMI_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VCMI_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VCMI_VERSION_PATCH})

# vcmi does not have "patch version" in version string
set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
#TODO: remove version from Global.h and use this one as define?

set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)

if(WIN32)
	set(CPACK_MONOLITHIC_INSTALL 1)
	set(CPACK_PACKAGE_NAME "VCMI")
	set(CPACK_PACKAGE_VENDOR "VCMI team")
	set(CPACK_PACKAGE_FILE_NAME "vcmi-${CPACK_PACKAGE_VERSION}-win32")
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/license.txt")
	set(CPACK_PACKAGE_EXECUTABLES "VCMI_launcher;VCMI")
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_NAME}")
	set(CPACK_NSIS_PACKAGE_NAME "VCMI ${CPACK_PACKAGE_VERSION}")
	set(CPACK_NSIS_INSTALL_ROOT "$PROGRAMFILES")
	set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS " CreateShortCut \\\"$DESKTOP\\\\VCMI.lnk\\\" \\\"$INSTDIR\\\\VCMI_launcher.exe\\\"")
    set(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS " Delete \\\"$DESKTOP\\\\VCMI.lnk\\\" ")
	
	configure_file("${CMAKE_SOURCE_DIR}/cmake_modules/CMakeCPackOptions.cmake.in" "${CMAKE_BINARY_DIR}/CMakeCPackOptions.cmake" @ONLY)

=== AI/CMakeLists.txt ===
project(AI)
cmake_minimum_required(VERSION 2.6)

find_path(FUZZYLITE_INCLUDE_PATH NAMES fl/fuzzylite.h)
find_library(FUZZYLITE_LIB NAMES fuzzylite PATH_SUFFIXES dynamic)
mark_as_advanced(FUZZYLITE_INCLUDE_PATH FUZZYLITE_LIB)

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(FUZZYLITE FUZZYLITE_INCLUDE_PATH FUZZYLITE_LIB)
if (FUZZYLITE_FOUND)
    set (FUZZYLITE_LIBRARIES ${FUZZYLITE_LIB})
    set (FUZZYLITE_INCLUDE_DIR ${FUZZYLITE_INCLUDE_PATH})
endif()

if (NOT FUZZYLITE_FOUND)
    add_subdirectory(FuzzyLite/fuzzylite)
endif()
add_subdirectory(BattleAI)
add_subdirectory(StupidAI)
add_subdirectory(EmptyAI)
add_subdirectory(VCAI)

=== lib/CMakeLists.txt ===
project(libvcmi)
cmake_minimum_required(VERSION 2.6)

include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_CURRENT_SOURCE_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/lib)
include_directories(${Boost_INCLUDE_DIRS} ${SDL_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR})

set(lib_SRCS
		StdInc.cpp

		filesystem/AdapterLoaders.cpp
		filesystem/CCompressedStream.cpp
		filesystem/CFilesystemLoader.cpp
		filesystem/CArchiveLoader.cpp
		filesystem/CFileInfo.cpp
		filesystem/CMemoryStream.cpp
		filesystem/CBinaryReader.cpp
		filesystem/CFileInputStream.cpp
		filesystem/CZipLoader.cpp
		filesystem/Filesystem.cpp
		filesystem/ResourceID.cpp

		mapObjects/CArmedInstance.cpp
		mapObjects/CBank.cpp
		mapObjects/CGHeroInstance.cpp
		mapObjects/CGMarket.cpp
		mapObjects/CGPandoraBox.cpp
		mapObjects/CGTownInstance.cpp
		mapObjects/CObjectClassesHandler.cpp
		mapObjects/CObjectHandler.cpp
		mapObjects/CommonConstructors.cpp
		mapObjects/CQuest.cpp
		mapObjects/CRewardableConstructor.cpp
		mapObjects/CRewardableObject.cpp
		mapObjects/JsonRandom.cpp
		mapObjects/MiscObjects.cpp
		mapObjects/ObjectTemplate.cpp

		logging/CBasicLogConfigurator.cpp
		logging/CLogger.cpp

		mapping/CCampaignHandler.cpp
		mapping/CMap.cpp
		mapping/CMapEditManager.cpp
		mapping/CMapInfo.cpp
		mapping/CMapService.cpp
		mapping/MapFormatH3M.cpp
		mapping/MapFormatJson.cpp

		rmg/CMapGenerator.cpp
		rmg/CMapGenOptions.cpp
		rmg/CRmgTemplate.cpp
		rmg/CRmgTemplateZone.cpp
		rmg/CRmgTemplateStorage.cpp
		rmg/CZoneGraphGenerator.cpp
		rmg/CZonePlacer.cpp

		BattleAction.cpp
		BattleHex.cpp
		BattleState.cpp
		CArtHandler.cpp
		CBattleCallback.cpp
		CBonusTypeHandler.cpp
		CBuildingHandler.cpp
		CConfigHandler.cpp
		CConsoleHandler.cpp
		CCreatureHandler.cpp
		CCreatureSet.cpp
		CGameInterface.cpp
		CGeneralTextHandler.cpp
		CHeroHandler.cpp
		CModHandler.cpp
		CObstacleInstance.cpp
		CRandomGenerator.cpp
		CSpellHandler.cpp
		CThreadHelper.cpp
		CTownHandler.cpp
		GameConstants.cpp
		HeroBonus.cpp
		JsonDetail.cpp
		JsonNode.cpp
		LogicalExpression.cpp
		ResourceSet.cpp
		VCMI_Lib.cpp
		VCMIDirs.cpp
		IHandlerBase.cpp

		IGameCallback.cpp
		CGameInfoCallback.cpp
		CGameState.cpp
		Connection.cpp
		NetPacksLib.cpp

		registerTypes/RegisterTypes.cpp
		registerTypes/TypesClientPacks1.cpp
		registerTypes/TypesClientPacks2.cpp
		registerTypes/TypesMapObjects1.cpp
		registerTypes/TypesMapObjects2.cpp
				registerTypes/TypesMapObjects3.cpp
		registerTypes/TypesPregamePacks.cpp
		registerTypes/TypesServerPacks.cpp
)

set(lib_HEADERS
		../Global.h

		filesystem/CInputStream.h
		filesystem/ISimpleResourceLoader.h

		mapObjects/MapObjects.h

		CSoundBase.h
		AI_Base.h
		CondSh.h
		ConstTransitivePtr.h
		CBonusTypeHandler.h
		CScriptingModule.h
		CStopWatch.h
		FunctionList.h
		GameConstants.h
		StringConstants.h
		IGameEventsReceiver.h
		int3.h
		CGameStateFwd.h
		Interprocess.h
		NetPacks.h
		NetPacksBase.h
		StartInfo.h
		UnlockGuard.h
		VCMIDirs.h
		vcmi_endian.h
)

add_library(vcmi SHARED ${lib_SRCS} ${lib_HEADERS})
set_target_properties(vcmi PROPERTIES XCODE_ATTRIBUTE_LD_DYLIB_INSTALL_NAME "@rpath/libvcmi.dylib")
set_target_properties(vcmi PROPERTIES COMPILE_DEFINITIONS "VCMI_DLL=1")
target_link_libraries(vcmi ${MINIZIP_LIBRARIES} ${Boost_LIBRARIES} ${SDL_LIBRARY} ${ZLIB_LIBRARIES} ${SYSTEM_LIBS})

if(WIN32)
	set_target_properties(vcmi PROPERTIES OUTPUT_NAME VCMI_lib)
endif()

set_target_properties(vcmi PROPERTIES ${PCH_PROPERTIES})
cotire(vcmi)

if (NOT APPLE) # Already inside vcmiclient bundle
	install(TARGETS vcmi RUNTIME DESTINATION ${LIB_DIR} LIBRARY DESTINATION ${LIB_DIR})
endif()

=== AI/VCAI/CMakeLists.txt ===
project(VCAI)
cmake_minimum_required(VERSION 2.6)

add_definitions(-DFL_CPP11) #TODO: Find a better way to set this macro for fuzzylite

if (FUZZYLITE_FOUND)
    include_directories(${Boost_INCLUDE_DIRS} ${CMAKE_HOME_DIRECTORY} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib ${FUZZYLITE_INCLUDE_DIR})
else()
    include_directories(${Boost_INCLUDE_DIRS} ${CMAKE_HOME_DIRECTORY} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib ${CMAKE_HOME_DIRECTORY}/AI/FuzzyLite/fuzzylite)
endif()

set(VCAI_SRCS
        StdInc.cpp
        VCAI.cpp
        Goals.cpp
        AIUtility.cpp
        main.cpp
        Fuzzy.cpp
)

add_library(VCAI SHARED ${VCAI_SRCS})
if (FUZZYLITE_FOUND)
    target_link_libraries(VCAI ${FUZZYLITE_LIBRARIES} vcmi)
else()
    target_link_libraries(VCAI fl-static vcmi)
endif()

set_target_properties(VCAI PROPERTIES ${PCH_PROPERTIES})
cotire(VCAI)

if (NOT APPLE) # Already inside vcmiclient bundle
    install(TARGETS VCAI RUNTIME DESTINATION ${AI_LIB_DIR} LIBRARY DESTINATION ${AI_LIB_DIR})
endif()

## vcmi 0.82svn1767-0maemo1

=== debian/changelog ===
vcmi (0.82svn1767-0maemo1) fremantle; urgency=low

  * Ported to Maemo 5 (Fremantle)

 -- Daniel Spies <daniel.spies@fuceekay.com>  Mon, 28 Jun 2010 00:10:00 +0100

vcmi (0.80-1) unstable; urgency=low

  * New upstream release

 -- Johannes Schauer <josch@pyneo.org>  Sat, 10 Apr 2010 11:29:08 +0100

vcmi (0.74-1) unstable; urgency=low

  * Initial release

 -- frank zago <frank@zago.net>  Sat, 03 Oct 2009 12:28:04 -0500

=== debian/control ===
Source: vcmi
Section: user/games
Priority: extra
Maintainer: Daniel Spies <daniel.spies@fuceekay.com>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.8.0
Homepage: http://vcmi.eu
XSBC-Bugtracker: mailto: daniel.spies@fuceekay.com

Package: vcmi
XB-Maemo-Display-Name: VCMI Heroes 3
Architecture: all
Depends: vcmi-bin (= ${binary:Version}), vcmi-data (= ${binary:Version})
Suggests: vcmi-video (= ${binary:Version})
Description: A rewrite of the Heroes of Might and Magic 3 engine
 NOTE: VCMI will not run without the binary files from the Heroes of Might 
 and Magic 3 retail disk. Please follow the instructions on 
 http://forum.vcmi.eu/ and the Wiki.
 . 
 The purpose of VCMI project is to rewrite entire HOMM 3: WoG engine from
 scratch, giving it new and extended possibilities. It will help to support
 mods and new towns already made by fans but abandoned because of game code
 limitations.
 .
 In its current state it already supports maps of any sizes, higher
 resolutions and extended engine limits.
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAKT2lDQ1BQaG90
 b3Nob3AgSUNDIHByb2ZpbGUAAHjanVNnVFPpFj333vRCS4iAlEtvUhUIIFJC
 i4AUkSYqIQkQSoghodkVUcERRUUEG8igiAOOjoCMFVEsDIoK2AfkIaKOg6OI
 isr74Xuja9a89+bN/rXXPues852zzwfACAyWSDNRNYAMqUIeEeCDx8TG4eQu
 QIEKJHAAEAizZCFz/SMBAPh+PDwrIsAHvgABeNMLCADATZvAMByH/w/qQplc
 AYCEAcB0kThLCIAUAEB6jkKmAEBGAYCdmCZTAKAEAGDLY2LjAFAtAGAnf+bT
 AICd+Jl7AQBblCEVAaCRACATZYhEAGg7AKzPVopFAFgwABRmS8Q5ANgtADBJ
 V2ZIALC3AMDOEAuyAAgMADBRiIUpAAR7AGDIIyN4AISZABRG8lc88SuuEOcq
 AAB4mbI8uSQ5RYFbCC1xB1dXLh4ozkkXKxQ2YQJhmkAuwnmZGTKBNA/g88wA
 AKCRFRHgg/P9eM4Ors7ONo62Dl8t6r8G/yJiYuP+5c+rcEAAAOF0ftH+LC+z
 GoA7BoBt/qIl7gRoXgugdfeLZrIPQLUAoOnaV/Nw+H48PEWhkLnZ2eXk5NhK
 xEJbYcpXff5nwl/AV/1s+X48/Pf14L7iJIEyXYFHBPjgwsz0TKUcz5IJhGLc
 5o9H/LcL//wd0yLESWK5WCoU41EScY5EmozzMqUiiUKSKcUl0v9k4t8s+wM+
 3zUAsGo+AXuRLahdYwP2SycQWHTA4vcAAPK7b8HUKAgDgGiD4c93/+8//Ueg
 JQCAZkmScQAAXkQkLlTKsz/HCAAARKCBKrBBG/TBGCzABhzBBdzBC/xgNoRC
 JMTCQhBCCmSAHHJgKayCQiiGzbAdKmAv1EAdNMBRaIaTcA4uwlW4Dj1wD/ph
 CJ7BKLyBCQRByAgTYSHaiAFiilgjjggXmYX4IcFIBBKLJCDJiBRRIkuRNUgx
 UopUIFVIHfI9cgI5h1xGupE7yAAygvyGvEcxlIGyUT3UDLVDuag3GoRGogvQ
 ZHQxmo8WoJvQcrQaPYw2oefQq2gP2o8+Q8cwwOgYBzPEbDAuxsNCsTgsCZNj
 y7EirAyrxhqwVqwDu4n1Y8+xdwQSgUXACTYEd0IgYR5BSFhMWE7YSKggHCQ0
 EdoJNwkDhFHCJyKTqEu0JroR+cQYYjIxh1hILCPWEo8TLxB7iEPENyQSiUMy
 J7mQAkmxpFTSEtJG0m5SI+ksqZs0SBojk8naZGuyBzmULCAryIXkneTD5DPk
 G+Qh8lsKnWJAcaT4U+IoUspqShnlEOU05QZlmDJBVaOaUt2ooVQRNY9aQq2h
 tlKvUYeoEzR1mjnNgxZJS6WtopXTGmgXaPdpr+h0uhHdlR5Ol9BX0svpR+iX
 6AP0dwwNhhWDx4hnKBmbGAcYZxl3GK+YTKYZ04sZx1QwNzHrmOeZD5lvVVgq
 tip8FZHKCpVKlSaVGyovVKmqpqreqgtV81XLVI+pXlN9rkZVM1PjqQnUlqtV
 qp1Q61MbU2epO6iHqmeob1Q/pH5Z/YkGWcNMw09DpFGgsV/jvMYgC2MZs3gs
 IWsNq4Z1gTXEJrHN2Xx2KruY/R27iz2qqaE5QzNKM1ezUvOUZj8H45hx+Jx0
 TgnnKKeX836K3hTvKeIpG6Y0TLkxZVxrqpaXllirSKtRq0frvTau7aedpr1F
 u1n7gQ5Bx0onXCdHZ4/OBZ3nU9lT3acKpxZNPTr1ri6qa6UbobtEd79up+6Y
 nr5egJ5Mb6feeb3n+hx9L/1U/W36p/VHDFgGswwkBtsMzhg8xTVxbzwdL8fb
 8VFDXcNAQ6VhlWGX4YSRudE8o9VGjUYPjGnGXOMk423GbcajJgYmISZLTepN
 7ppSTbmmKaY7TDtMx83MzaLN1pk1mz0x1zLnm+eb15vft2BaeFostqi2uGVJ
 suRaplnutrxuhVo5WaVYVVpds0atna0l1rutu6cRp7lOk06rntZnw7Dxtsm2
 qbcZsOXYBtuutm22fWFnYhdnt8Wuw+6TvZN9un2N/T0HDYfZDqsdWh1+c7Ry
 FDpWOt6azpzuP33F9JbpL2dYzxDP2DPjthPLKcRpnVOb00dnF2e5c4PziIuJ
 S4LLLpc+Lpsbxt3IveRKdPVxXeF60vWdm7Obwu2o26/uNu5p7ofcn8w0nyme
 WTNz0MPIQ+BR5dE/C5+VMGvfrH5PQ0+BZ7XnIy9jL5FXrdewt6V3qvdh7xc+
 9j5yn+M+4zw33jLeWV/MN8C3yLfLT8Nvnl+F30N/I/9k/3r/0QCngCUBZwOJ
 gUGBWwL7+Hp8Ib+OPzrbZfay2e1BjKC5QRVBj4KtguXBrSFoyOyQrSH355jO
 kc5pDoVQfujW0Adh5mGLw34MJ4WHhVeGP45wiFga0TGXNXfR3ENz30T6RJZE
 3ptnMU85ry1KNSo+qi5qPNo3ujS6P8YuZlnM1VidWElsSxw5LiquNm5svt/8
 7fOH4p3iC+N7F5gvyF1weaHOwvSFpxapLhIsOpZATIhOOJTwQRAqqBaMJfIT
 dyWOCnnCHcJnIi/RNtGI2ENcKh5O8kgqTXqS7JG8NXkkxTOlLOW5hCepkLxM
 DUzdmzqeFpp2IG0yPTq9MYOSkZBxQqohTZO2Z+pn5mZ2y6xlhbL+xW6Lty8e
 lQfJa7OQrAVZLQq2QqboVFoo1yoHsmdlV2a/zYnKOZarnivN7cyzytuQN5zv
 n//tEsIS4ZK2pYZLVy0dWOa9rGo5sjxxedsK4xUFK4ZWBqw8uIq2Km3VT6vt
 V5eufr0mek1rgV7ByoLBtQFr6wtVCuWFfevc1+1dT1gvWd+1YfqGnRs+FYmK
 rhTbF5cVf9go3HjlG4dvyr+Z3JS0qavEuWTPZtJm6ebeLZ5bDpaql+aXDm4N
 2dq0Dd9WtO319kXbL5fNKNu7g7ZDuaO/PLi8ZafJzs07P1SkVPRU+lQ27tLd
 tWHX+G7R7ht7vPY07NXbW7z3/T7JvttVAVVN1WbVZftJ+7P3P66Jqun4lvtt
 Xa1ObXHtxwPSA/0HIw6217nU1R3SPVRSj9Yr60cOxx++/p3vdy0NNg1VjZzG
 4iNwRHnk6fcJ3/ceDTradox7rOEH0x92HWcdL2pCmvKaRptTmvtbYlu6T8w+
 0dbq3nr8R9sfD5w0PFl5SvNUyWna6YLTk2fyz4ydlZ19fi753GDborZ752PO
 32oPb++6EHTh0kX/i+c7vDvOXPK4dPKy2+UTV7hXmq86X23qdOo8/pPTT8e7
 nLuarrlca7nuer21e2b36RueN87d9L158Rb/1tWeOT3dvfN6b/fF9/XfFt1+
 cif9zsu72Xcn7q28T7xf9EDtQdlD3YfVP1v+3Njv3H9qwHeg89HcR/cGhYPP
 /pH1jw9DBY+Zj8uGDYbrnjg+OTniP3L96fynQ89kzyaeF/6i/suuFxYvfvjV
 69fO0ZjRoZfyl5O/bXyl/erA6xmv28bCxh6+yXgzMV70VvvtwXfcdx3vo98P
 T+R8IH8o/2j5sfVT0Kf7kxmTk/8EA5jz/GMzLdsAAAAGYktHRAD/AP8A/6C9
 p5MAAAAJcEhZcwAACxMAAAsTAQCanBgAAAAHdElNRQfaBhwJOQmSd4b/AAAN
 6klEQVRo3u2ZWZBcV3nHf+ece2/37emerWemZ0YjeaSRJdkSkrDBFpIdJLxR
 pFiTwgmVCkuRCuGB8BBSleQ1RZFKwQOQAKmEQFhNjCvgUGXAeJVly7FstGus
 ZaTRjEazdk/37bvfc/LQM0IYSWhESPLgr+rU7Trdfe///23n+74Lr8vr8rpc
 UT7y4Q//v8P08T/9k1/ZE9f6w6aNG9Vb3rKjPLx2uNNv+vG58XHvuw99L8CY
 CEh/Szitck9f7t63vdUtd3cVhcQ5d+58bXJicu6Vg4f0r/z4Wne666671q5f
 v/5v+/p6dwW+P9fR3n5s1eDgqOd5Y24+fyGfz1UNNBsNL7xwYSo4eOhwPDZ2
 JgESwCyty5UlAImQ9u23vdFev36d09nRkXPzbh6jiw2v0eMHwWBboW24vVTc
 kHfzt0gpepIo3t/0vL8AxlZEYO3atdu2bNnyYLFYRGfpkNZ6uzGaIAioVquZ
 53m1KI5mujo7Z/orfRO3bNowF4ZRNU7iGoZUmywBYYwxGGMsY4xSSrm2pboc
 x+nM5XJlKWXFUqpiWVZl9epVnYWCKzCGOI5J0wRjDHkn977z5yf+DTgH6Osm
 4AdB1vR94ziOkFIiLdsIIShatsi7BZUmcTlNknKWZbdoo1v+KARGa7JMk6Qx
 xoAxGhAIYRBCkqUpWZaRpilaZ2RZhjEGrTPiKEK3GCOEFEKAQYMguaK/XYtA
 o96YHTtzppoMDXW3FYukcSS8xRq5fJ5CsR0nlyNfyGGMJk0S0iQmzVKTaS20
 0UgpMdqgERhtyLRGZ6kxxghjDAiBEBJtUpI4AaORQoDWAiFQSiGEwG8GjVKp
 OPVa7f9aAvPzc7U0TSYCP+gutrczfuIwoy/to7Pcw8CaYSqDQ3T39lFoKyIt
 CyElpuUzaMBojTamddUaozOMNsIYjdG6hccYlNZYEpRU2JZCCUnVD9AGLNsi
 jOPzSlm1FVtgdm6uYYw5C2br7MKCOXP0sDh77CS5/EnOHT9IubePnsoA5Uo/
 7Z3d5FwXy3ZQlo1Y0p4QAiGXrsuRLARSCJQQWJbEzecpuC6WZSGlxHEcmpPT
 BBpjWZaIo3h0oVprrpjAs888s3jvvfedaiu0kWYRRiqsXCu1+E2fNJki9APi
 MCCLQjo7u3ByOaSUKEuhlGqBsiyUslBKoazlq0RJC2W1iMZJTJZlKEsRRhEI
 SS5nY1kWnt888sRTT/srJhCEYTMMg7EgCEizTBipkLYNaYIxEEURc7Oz+L5P
 o75IZWAVPX0ViqUSiOU8KsgMWNqgtSbTukUgs1CWRmmFVAqlLYxqZV3PD1BW
 jlzeFWEYEsfJq0mcBCsmsHRYTdQb9QhETiNRTo4sSRASjAGtNc1GgzgKaTYa
 NOp1KgMDdHW3XErrlo8vx4HSmqW0ijZ66XvTCnbdiok4SRFOASfnMDc313Tz
 7lkguxECSCmnwjCcwDCSGoG0nEt3EkvnuDEQxwkL8/MEl6wxQF9lgFJHxyXw
 +nLwy2S0xmiFNhbKaITRZAgcZWNZNn4QnEEwc9Vj+9cR8INgVgl5UghGEmMM
 yhaYlnuIpaNWLH3Q2uD7PvGFSZqeh1ev0zcwSLmnh7xbAKOvAH7JMsaANqA1
 0nZxXNc4tiOCMDo4OnqydlUFv3bju3//V78cyM8+Ox1F4QkhBFGciUhL9OVF
 lIE4hjCGKIYwAq+ZUp2fZ3xsjFOjJzh75gyzMzPUvQjfT4jjmCRJWitNiJMU
 309oBgkNzydfKNLZ3SOUnWO2Gv3Xc/uer16NgHrtxsM/3csdW3cV37tn4AMf
 +t3ej5baKuGMJ2NLqncO98YM9wlq1YA4agWydArsuLPM1i0lbh4psWF9iU0b
 25maVwQNjzBo0mw2KXUohld55GyPWgMs6QCGME6Iw3k63SlsZphvRBR71tHT
 P8jkyf10pi+XlPFPnzzvTVz3QdbTkStsXz93/z23T7471SNj+x/NvVRyxcx9
 t8/0re31+eyky5m6j5V3uWndav78gz4jaxRaSxCghM9ffm6I/S8JwnoVr7HI
 xuEqH3nHERbqeb735G14gUuxLUfDSxgqT/Dg7uMYnfLI/u3MN2K6vYge56i5
 b+fpuyYngjf+6Dmev1IFbF0lcCXGuFEcF0bPeqvHTpw6Xty86VyaJn1SpTj5
 NpTtsuXWLj7xwUn+/SdFfrZ3liyJyYxh7dpVfOaTo/xraZD/+EH1UuCmWas4
 m5ia5uykxxs2reXCfIRNDUFImmWEUcRU9aLJ513RFTVMkiYiybR9tdJfXWmz
 ze0152dskWSlVe/YlXv3to3Dt91/e73NsZ3y1366itn5DEdqevsKbNvkceCY
 y6nRJqGfkkZQqxsOn+rh6GhI6DURUjAy0kG5y+fbP97Agw9I0sTipVdmuOMN
 KTu2NNh/rIySilcnXU5eLAjPa6R2eDLtbfesF49Gjx84Ee2/bgu8cmJ/E/jB
 usHyzdtu7rwjjOJiFM+ZZlIipBdVSJFJhJQONQ8yo7AdG5O1qk8dNjh6yGvl
 1yUJE5itGo6cDHnnW6HRrHL2bJOtt3Sw2GgwfnENfZ0WfpgR+j4XfH+hXGng
 +bIviq/ed10rjaZRYrJmYIhig+drRM5lZGSEakcbF0d9NIZGIAAbt1BAmIw0
 SVrlsTa/dLMkhUYgiCLFsbEOyuUF7t6Vp6Ndcnysh7lqih8awig1YRgIzw+P
 Rx1h2QtFX3yN3k9eg4CRsjsxVMjZqiBkV5tbGGbz5i28addddPdVSDODH4BB
 USi00VYqkXddnLYuVq27ibZy73KmJU4FQQh+PeArX/05OSdhz51n0Hqa7z+6
 yNnTE0SJIoi0CAKfhYXaAZ2EF/xAkNwIgVW9bvBPj5z66hceOvHpYiHuHT0z
 M/bcuY2P3rnzDvbsuYe1G25BG4tmIAmTlEaaEiCIlEVnf5n3vH2KLbcWL/WU
 aQpBKC491A8FdU8RhhKhM9IkI4gwUaRZXFyMa3XvFctSVT+6NoGrutDkbGCA
 qZGh0lHPl5Ta3HOiWNrf0dFx59Dq1X077v4dM3bimHjmQBtv2T7PrtscjHER
 AowJ2HtgK2NnpsnlHLIsI07AC1v68n3No48ZbHuIOIoJmrNoXJqRIoyhXm8c
 mZysHdOmcL8fSdJMZtd9kP2KJSpr25KsXK56haefOXDixd9777u3Vvr6hjvL
 veLYy/sYHztL3c8xOa0YvyAZn5Scn8pxcTpGpAFKKZCSKMmzUGtj9mIdHYWE
 Xh2/vkjc9BBGY5wuPNaI6apkvtZ4pFY9/9CagQ1dQdydnZ2KfjR+sXpqxR3Z
 P/71g3z80w+9ALxv+fcXJicODvRXdvf39zO84VZePXKIxfloqfddrjINShhU
 Po9j21hRRKNaZXYyxOgUIUFcVk8JS+EZx4xO+iKNo6ZliRcB7zuP7f8y8OVr
 YbymBX707NHXbunNWzZ3lUqlXe3tpWKSZub0sUMiaNZRSiGlQEqBkq2Oa7n7
 siwL27axlpoXYwxmqSI0BqRbxO7qF5aliON4/3y1+i++789czxBJsUJ5ft/z
 3p49u9+slFzf3tUtTh47zPz0RYRYahiX2khes+RSd6aWemcAozOwLNoHh03X
 4BqRpQlBGH5rfHz84Su5y/8IgSRJatu2bl0HemfOtq2G1zTT58dEmsSXtH6l
 8d+yNZRlXep9wdBZGeS23Q/QPzAo0iQ9PTs7+6W5+flXrxfPigm0aiURrRoc
 3KGzpN8tlsTF8bMEjUUua9svWeJK1lBSIpUiX2jjzXvuNw+85/0i7zikafqD
 H/7no18FwuvGciMEHv/ZE/vn5+f2Vqu1DAz9IxuNnXdbuGVrCiEvI7C8pPjF
 vpSSkc1b+cBHP872bVtZc9NNF+IkeQyorUiZKwX/vne9C8A8t++F7y9UF07X
 F2v0r76JjsoqpFJLICVCSIT8xZKXfTZAsaOLe971++YN27aLQsEll889/fkv
 fP7xFXvDSv/wyA9/uGyFp6anZx5fXFxM0iQWQxtuNblixxLIX8yCLtf68mzI
 sm227ribu+97O2maMDMzc/7JJ598GFhYKZ4bioEdO3YwMTGB5wcXVw+t2gWm
 kncLAss2jYU5gU6v7P9LIT24fiP3vOf9pqOzU8zNzmWHDh387sc+9mdfvJGR
 /Q3FwAsvvADAkcNHXj556vTXG41Gvdmo09HTx8DNm5FuCWMuyz4IMAYjJP3r
 N7Ft524DRrx64jgvH3jplS9+8R++AoTGmBVjETf6FqJQKOD7PkD7H/3h+7/U
 X+n9A9txpFLKNBdrYnFummZ1niQKEUJSKLXTt3qYoXU3m3JvrxBA0w+m9+7d
 96lvfvs737hRHDdMAOCpp37M7t0PsG547YadO9/0z91dnXfbloVlOyZLU5El
 MRiDZSlyhTY6OrtNPp8XSkrCJG4e/Pmhz3z9G9/+OyCpVCpMT0/zvxIDy/K1
 r30TgGqtNq+1OZjP57bZlj2UpolACGzbMbabF7mci7Jto3Um0iSh0WgEPz94
 6LPf+s73PgcEH/nQH7P3uX03hOE3InC5zMzOTdm2/XySxh05x95qjCHLMpGl
 GWmWorNMJEnCxemZc4ePHv+bn/zsia+kSdp49unH+MQnP8X/iQtdNsVozTWB
 W2/d2OM6ud8pl7s/UCjkdzqO0yWESNM0PV1vNB9tNv2H973w4nEgPvDi09x+
 x1t/o2cLfjui3nTb9g7HtjoNxpVSZUrJ+uip04vTF2ebAA/c+zZ+/PgTr7/P
 fl1el99Q/huzqVKzjN+U0QAAAABJRU5ErkJggg==
 ====

## vcmi 0.82svn1767-0maemo2

=== debian/changelog ===
vcmi (0.82svn1767-0maemo2) fremantle; urgency=low

  * Bumped version for the vcmi-bin binary fix

 -- Daniel Spies <daniel.spies@fuceekay.com>  Sat, 21 Aug 2010 23:06:00 +0100

## vcmi 0.82svn1767-0maemo3

=== debian/changelog ===
vcmi (0.82svn1767-0maemo3) fremantle; urgency=low

  * Bumped version for the vcmi-bin binary fix

 -- Daniel Spies <daniel.spies@fuceekay.com>  Sun, 22 Aug 2010 23:44:00 +0100

## vcmi 0.82svn1767-0maemo4

=== debian/changelog ===
vcmi (0.82svn1767-0maemo4) fremantle; urgency=low

  * Bumped version

 -- Daniel Spies <daniel.spies@fuceekay.com>  Mon, 23 Aug 2010 00:52:00 +0100

## vcmi 0.82svn1767-0maemo5

=== debian/changelog ===
vcmi (0.82svn1767-0maemo5) fremantle; urgency=low

  * Bumped version

 -- Daniel Spies <daniel.spies@fuceekay.com>  Tue, 24 Aug 2010 00:10:00 +0100

## vcmi 0.82svn1775-0maemo1

=== debian/changelog ===
vcmi (0.82svn1775-0maemo1) fremantle; urgency=low

  * New upstream release

 -- Daniel Spies <daniel.spies@fuceekay.com>  Wed, 25 Aug 2010 12:04:00 +0100

## vcmi 0.82svn1781-0maemo1

=== debian/changelog ===
vcmi (0.82svn1781-0maemo1) fremantle; urgency=low

  * New upstream release

 -- Daniel Spies <daniel.spies@fuceekay.com>  Fri, 27 Aug 2010 12:47:00 +0100

## vcmi 0.84svn2018-0maemo0

=== debian/changelog ===
vcmi (0.84svn2018-0maemo0) fremantle; urgency=low

  * New upstream release
  * Added HAM installation popup (dependencies on third party binaries)

 -- Daniel Spies <daniel.spies@fuceekay.com>  Sun, 06 Mar 2011 15:05:00 +0100

## vcmi 0.86dsvn2473-0maemo0

=== debian/changelog ===
vcmi (0.86dsvn2473-0maemo0) fremantle; urgency=low

  * New upstream release

 -- Holger Nahrstaedt <holgernahrstaedt@gmx.de>  Th, 27 Mar 2012 15:05:00 +0100

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
 Package: vcmi
 XB-Maemo-Display-Name: VCMI Heroes 3
 Architecture: all
+Pre-Depends: maemo-installer-utils
 Depends: vcmi-bin (= ${binary:Version}), vcmi-data (= ${binary:Version})
 Suggests: vcmi-video (= ${binary:Version})
 Description: A rewrite of the Heroes of Might and Magic 3 engine

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
#DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
#DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	#./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"


build: build-stamp

build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	#$(MAKE)
	#docbook-to-man debian/vcmi-0.81b.sgml > vcmi-0.81b.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	#-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/vcmi-0.81b.
	#$(MAKE) DESTDIR=$(CURDIR)/debian/vcmi install

	mkdir -p "$(CURDIR)/debian/vcmi/usr/share/applications/hildon/"
	cp -a "maemo/vcmi.desktop" "$(CURDIR)/debian/vcmi/usr/share/applications/hildon/vcmi.desktop"
	mkdir -p "$(CURDIR)/debian/vcmi/usr/share/icons/hicolor/scalable/hildon/"
	cp -a "maemo/vcmi_64x64.png" "$(CURDIR)/debian/vcmi/usr/share/icons/hicolor/scalable/hildon/vcmi.png"

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## vcmi 0.86dsvn2473-0maemo1

=== debian/changelog ===
vcmi (0.86dsvn2473-0maemo1) fremantle; urgency=low

  * New upstream release

 -- Holger Nahrstaedt <holgernahrstaedt@gmx.de>  Th, 27 Mar 2012 15:05:00 +0100

## vcmi 0.97+dfsg

=== debian/changelog ===
vcmi (0.97+dfsg-4) unstable; urgency=medium

  * change my email in Uploaders field to josch@debian.org
  * d/watch: use repacksuffix and use dversionmangle instead of uversionmangle
  * d/rules: add get-orig-source target
  * add debian/patches/20150204-let-vcmibuilder-be-case-insensitive
    (Closes: #771300)

 -- Johannes Schauer <josch@debian.org>  Wed, 04 Feb 2015 16:20:56 +0100

vcmi (0.97+dfsg-3) unstable; urgency=medium

  [ Johannes Schauer ]
  * d/rules: remove --parallel from dh invocation. (Closes: #769864)
      - Each c++ process might take up to 2.5 GB of RAM. Arm buildds only have
        4 GB of RAM but build with DEB_BUILD_OPTIONS=parallel=5. This means
        that the build might consume 12 GB of RAM at a time which brings the
        buildd to a standstill as 8 GB have to be swapped out.

 -- Stephen Kitt <skitt@debian.org>  Fri, 28 Nov 2014 20:05:24 +0100

vcmi (0.97+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Johannes Schauer ]
  * d/control: Adding Vcs headers
  * d/control: Adding pkg-games team as maintainer
  * d/control: Adding Stephen Kitt as uploader
  * add d/patches/20141103-disable-privacy-breach to not automatically connect
    to the vcmi.eu server on vcmilauncher startup
  * add d/patches/20141117-add-FL_CPP11-preprocessor-define to fix a build
    failure on kFreeBSD
  * add d/patches/20141117-add-kfreebsd-and-hurd-support to support kFreeBSD
    and the HURD

  [ Stephen Kitt ]
  * Add Johannes as uploader.

 -- Stephen Kitt <skitt@debian.org>  Tue, 18 Nov 2014 22:48:23 +0100

vcmi (0.97+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #741640)

 -- Johannes Schauer <josch@mister-muffin.de>  Fri, 07 Nov 2014 07:31:44 +0100

## vcmi 0.98%2Bdfsg

=== debian/rules ===
#! /usr/bin/make -f

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDDIR=$(CURDIR)/build

%:
	dh $@ --builddirectory=$(BUILDDIR)

# override disabled by default rpath - we need to find libvcmi.so with it:
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=OFF -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBIN_DIR=games

override_dh_strip:
	dh_strip --dbg-package=vcmi-dbg

# we have to set HOME to a temporary directory when running vcmiserver because
#  - when running vcmiserver it wants to create $HOME/.config/vcmi,
#    $HOME/.cache/vcmi and $HOME/.local/share/vcmi/Saves
#  - sbuild uses the non-existing path /sbuild-nonexistent and the vcmiserver
#    invocation would fail because it cannot create it
#  - we don't want to touch the home directory of the user running dpkg-buildpackage
%.1: debian/%.1.in
	HOME=$(BUILDDIR) help2man --version-string=$(DEB_VERSION_UPSTREAM) --include=$< --output=$@ ./`basename $@ .1`

override_dh_installman: vcmiserver.1 vcmibuilder.1 vcmiclient.1
	dh_installman

override_dh_auto_install:
	dh_auto_install --destdir=debian/vcmi

override_dh_auto_build:
	dh_auto_build
	ln -s $(BUILDDIR)/server/vcmiserver ./vcmiserver
	ln -s $(BUILDDIR)/client/vcmiclient ./vcmiclient
	htlatex vcmimanual.tex

override_dh_auto_clean:
	dh_auto_clean
	rm -f ./vcmiclient ./vcmiserver
	rm -f vcmimanual.4ct vcmimanual.4tc vcmimanual.aux vcmimanual.css \
	vcmimanual.dvi vcmimanual.html vcmimanual.idv vcmimanual.lg \
	vcmimanual.log vcmimanual.tmp vcmimanual.xref

get-orig-source:
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --repack --compression=xz --download-current-version
